/*////////////////////////////////////////////////////////////////////////////
    PROJECT:    System Manager
    COPYRIGHT    2011 Dean J. Boman

    FILE:       Time_conversion.h
    AUTHOR:     Dean J. Boman

    OVERVIEW:
        This routine converts the output of the SNTP function (seconds since Jan 1, 1970) to real time
        with a specific UTC offset.
        
        This code is an adaptation of code found on the Microchip forum dated Nov. 14, 2007 under the title 
        "Time in web page" under the Ethernet heading.  For the current implementation the Time structure was
        modifed to conform to the existing code and a time zone correction factor was added.



    REVISION HISTORY:

	Dec. 15. 2011	Initial adaptation





*/////////////////////////////////////////////////////////////////////////////
#ifndef _TIMECONVERSION_H
#define _TIMECONVERSION_H

#include "typedef.h"

#define GMT_OFFSET	7

//Define real time variable
typedef struct 
{
	uint8 Second;
	uint8 Minute;
	uint8 Hour;
	uint8 Month;
	uint8 Day;
	uint8 Year;
	uint8 WeekDay;
    uint16 DayOfYear; 
} TIME;



//Prototpe
void BinaryToDate(unsigned long binary,TIME *datetime);


#endif // _TIMECONVERSION_H